Index: /LMDZ6/trunk/libf/dyn3d/iniacademic.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3d/iniacademic.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/dyn3d/iniacademic.F90	(revision 4056)
@@ -5,7 +5,9 @@
 
   USE filtreg_mod, ONLY: inifilr
-  USE infotrac,    ONLY: nqtot,niso_possibles,ok_isotopes,ok_iso_verif,tnat,alpha_ideal, &
-        & iqiso,iso_indnum, tracers
+  USE infotrac,    ONLY: nqtot, niso_possibles, ok_isotopes, ok_iso_verif, tnat, alpha_ideal, &
+                         iqiso, tracers, iso_indnum
   USE control_mod, ONLY: day_step,planet_type
+  use exner_hyb_m, only: exner_hyb
+  use exner_milieu_m, only: exner_milieu
 #ifdef CPP_IOIPSL
   USE IOIPSL, ONLY: getin
@@ -15,6 +17,4 @@
 #endif
   USE Write_Field
-  use exner_hyb_m, only: exner_hyb
-  use exner_milieu_m, only: exner_milieu
   USE comconst_mod, ONLY: cpp, kappa, g, daysec, dtvr, pi, im, jm
   USE logic_mod, ONLY: iflag_phys, read_start
@@ -62,5 +62,5 @@
   real tetastrat ! potential temperature in the stratosphere, in K
   real tetajl(jjp1,llm)
-  INTEGER i,j,l,lsup,ij, iq
+  INTEGER i,j,l,lsup,ij, iq, iName, iZone, iPhase, iqParent
 
   REAL teta0,ttp,delt_y,delt_z,eps ! Constantes pour profil de T
@@ -71,5 +71,5 @@
 
   real zz,ran1
-  integer idum, iqParent, iName, iZone, iPhase
+  integer idum
 
   REAL zdtvr
@@ -77,5 +77,4 @@
   character(len=*),parameter :: modname="iniacademic"
   character(len=80) :: abort_message
-
 
   ! Sanity check: verify that options selected by user are not incompatible
@@ -131,7 +130,9 @@
         ps(:)=preff
      endif
+
      ! ground geopotential
      phis(:)=0.
      CALL pression ( ip1jmp1, ap, bp, ps, p       )
+
      if (pressure_exner) then
        CALL exner_hyb( ip1jmp1, ps, p, pks, pk)
@@ -194,5 +195,4 @@
      CALL getin('tetanoise',tetanoise)
 
-
      ! 2. Initialize fields towards which to relax
      ! Friction
@@ -247,5 +247,4 @@
      IF (.NOT. read_start) THEN
         ! bulk initialization of temperature
-
         IF (iflag_phys>10000) THEN
         ! Particular case to impose a constant temperature T0=0.01*iflag_physx
@@ -254,5 +253,4 @@
            teta(:,:)=tetarappel(:,:)
         ENDIF
-
         ! geopotential
         CALL geopot(ip1jmp1,teta,pk,pks,phis,phi)
@@ -287,6 +285,6 @@
               iName = tracers(iq)%iso_iName
               if (.NOT.ok_isotopes .OR. iName <= 0) CYCLE
-              iZone = tracers(iq)%iso_iZone
-              iPhase= tracers(iq)%iso_iPhase
+              iZone    = tracers(iq)%iso_iZone
+              iPhase   = tracers(iq)%iso_iPhase
               iqParent = tracers(iq)%iqParent
               if (iZone == 0) q(:,:,iq) = q(:,:,iqParent)*tnat(iName) &
@@ -298,7 +296,5 @@
         endif ! of if (planet_type=="earth")
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,1,ip1jmp1,'iniacademic_loc')
-        endif !if (ok_iso_verif) then
+        if (ok_iso_verif) call check_isotopes_seq(q,1,ip1jmp1,'iniacademic_loc')
 
         ! add random perturbation to temperature
Index: /LMDZ6/trunk/libf/dyn3d_common/infotrac.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3d_common/infotrac.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/dyn3d_common/infotrac.F90	(revision 4056)
@@ -14,14 +14,6 @@
   INTEGER, SAVE :: nbtr
 
-! CRisi: on retranche les isotopes des traceurs habituels
-! On fait un tableaux d'indices des traceurs qui passeront dans phytrac
+! Nombre de traceurs passes a phytrac
   INTEGER, SAVE :: nqtottr
-  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE :: itr_indice
-
-! CRisi: nb traceurs peres= directement advectes par l'air
-  INTEGER, SAVE :: nqperes
-
-! ThL: nb traceurs INCA
-  INTEGER, SAVE :: nqINCA
 
 ! ThL: nb traceurs CO2
@@ -31,8 +23,4 @@
   TYPE(trac_type), TARGET,  SAVE, ALLOCATABLE ::  tracers(:)    !=== TRACERS DESCRIPTORS VECTOR
   TYPE(isot_type), TARGET,  SAVE, ALLOCATABLE :: isotopes(:)    !=== ISOTOPES PARAMETERS VECTOR
-
-! niadv : vector keeping the coorspondance between all tracers(nqtot) treated in the 
-!         dynamic part of the code and the tracers (nbtr+2) used in the physics part of the code. 
-  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: niadv ! equivalent dyn / physique
 
   REAL :: qperemin,masseqmin,ratiomin ! MVals et CRisi
@@ -59,15 +47,4 @@
   INTEGER,SAVE :: niso,ntraceurs_zone,ntraciso
 
-#ifdef CPP_StratAer
-!--CK/OB for stratospheric aerosols
-  INTEGER, SAVE :: nbtr_bin
-  INTEGER, SAVE :: nbtr_sulgas
-  INTEGER, SAVE :: id_OCS_strat
-  INTEGER, SAVE :: id_SO2_strat
-  INTEGER, SAVE :: id_H2SO4_strat
-  INTEGER, SAVE :: id_BIN01_strat
-  INTEGER, SAVE :: id_TEST_strat
-#endif
- 
 CONTAINS
 
@@ -120,6 +97,7 @@
     LOGICAL :: continu,nouveau_traceurdef
     INTEGER :: IOstatus ! gestion de la retrocompatibilite de traceur.def
-    CHARACTER(len=maxlen) :: tchaine    
+    CHARACTER(len=maxlen) :: tchaine, msg1
     INTEGER, ALLOCATABLE  :: iqfils(:,:)
+    INTEGER :: nqINCA
 
     character(len=*),parameter :: modname="infotrac_init"
@@ -142,53 +120,40 @@
     descrq(30)='PRA'
     
-
-    ! Coherence test between parameter type_trac, config_inca and preprocessing keys
-    IF (type_trac=='inca') THEN
-       WRITE(lunout,*) 'You have chosen to couple with INCA chemistry model : type_trac=', &
-            type_trac,' config_inca=',config_inca
-       IF (config_inca/='aero' .AND. config_inca/='aeNP' .AND. config_inca/='chem') THEN
-          WRITE(lunout,*) 'Incoherence between type_trac and config_inca. Model stops. Modify run.def'
-          CALL abort_gcm('infotrac_init','Incoherence between type_trac and config_inca',1)
-       ENDIF
+    !--- MESSAGE ABOUT THE CHOSEN CONFIGURATION
+    WRITE(lunout,*)'type_trac='//TRIM(type_trac)
+    msg1 = 'For type_trac = "'//TRIM(type_trac)//'":'
+    SELECT CASE(type_trac)
+      CASE('inca'); WRITE(lunout,*)TRIM(msg1)//' coupling with INCA chemistry model, config_inca='//config_inca
+      CASE('inco'); WRITE(lunout,*)TRIM(msg1)//' coupling jointly with INCA and CO2 cycle'
+      CASE('repr'); WRITE(lunout,*)TRIM(msg1)//' coupling with REPROBUS chemistry model'
+      CASE('co2i'); WRITE(lunout,*)TRIM(msg1)//' you have chosen to run with CO2 cycle'
+      CASE('coag'); WRITE(lunout,*)TRIM(msg1)//' tracers are treated for COAGULATION tests'
+      CASE('lmdz'); WRITE(lunout,*)TRIM(msg1)//' tracers are treated in LMDZ only'
+      CASE DEFAULT
+        CALL abort_gcm(modname,'type_trac='//TRIM(type_trac)//' not possible yet.',1)
+    END SELECT
+
+    !--- COHERENCE TEST BETWEEN "type_trac", "config_inca" AND PREPROCESSING KEYS
+    SELECT CASE(type_trac)
+      CASE('inca','inco'); IF(ALL(['aero', 'aeNP', 'chem']/=config_inca)) &
+        CALL abort_gcm(modname, 'Incoherence between type_trac and config_inca. Please modify "run.def"',1)
 #ifndef INCA
-       WRITE(lunout,*) 'To run this option you must add cpp key INCA and compile with INCA code'
-       CALL abort_gcm('infotrac_init','You must compile with cpp key INCA',1)
+        CALL abort_gcm(modname, 'You must add cpp key INCA and compile with INCA code',1)
 #endif
-    ELSE IF (type_trac=='repr') THEN
-       WRITE(lunout,*) 'You have chosen to couple with REPROBUS chemestry model : type_trac=', type_trac
+      CASE('repr')
 #ifndef REPROBUS
-       WRITE(lunout,*) 'To run this option you must add cpp key REPROBUS and compile with REPRPBUS code'
-       CALL abort_gcm('infotrac_init','You must compile with cpp key REPROBUS',1)
+        CALL abort_gcm(modname, 'You must add cpp key REPROBUS and compile with REPROBUS code',1)
 #endif
-    ELSE IF (type_trac == 'co2i') THEN
-       WRITE(lunout,*) 'You have chosen to run with CO2 cycle: type_trac=', type_trac
-    ELSE IF (type_trac == 'coag') THEN
-       WRITE(lunout,*) 'Tracers are treated for COAGULATION tests : type_trac=', type_trac
+      CASE('coag')
 #ifndef CPP_StratAer
-       WRITE(lunout,*) 'To run this option you must add cpp key StratAer and compile with StratAer code'
-       CALL abort_gcm('infotrac_init','You must compile with cpp key StratAer',1)
+        CALL abort_gcm(modname, 'You must add cpp key StratAer and compile with StratAer code',1)
 #endif
-    ELSE IF (type_trac == 'lmdz') THEN
-       WRITE(lunout,*) 'Tracers are treated in LMDZ only : type_trac=', type_trac
-    ELSE IF (type_trac == 'inco') THEN ! ThL
-       WRITE(lunout,*) 'Using jointly INCA and CO2 cycle: type_trac =', type_trac
-       IF (config_inca/='aero' .AND. config_inca/='aeNP' .AND. config_inca/='chem') THEN
-          WRITE(lunout,*) 'Incoherence between type_trac and config_inca. Model stops. Modify run.def'
-          CALL abort_gcm('infotrac_init','Incoherence between type_trac and config_inca',1)
-       ENDIF
-#ifndef INCA
-       WRITE(lunout,*) 'To run this option you must add cpp key INCA and compilewith INCA code'
-       CALL abort_gcm('infotrac_init','You must compile with cpp key INCA',1)
-#endif    
-    ELSE
-       WRITE(lunout,*) 'type_trac=',type_trac,' not possible. Model stops'
-       CALL abort_gcm('infotrac_init','bad parameter',1)
-    ENDIF
-
-    ! Test if config_inca is other then none for run without INCA
-    IF (type_trac/='inca' .AND. type_trac/='inco' .AND. config_inca/='none') THEN
-       WRITE(lunout,*) 'config_inca will now be changed to none as you do not couple with INCA model'
-       config_inca='none'
-    ENDIF
+    END SELECT
+
+    !--- Disable "config_inca" option for a run without INCA if it differs from "none"
+    IF (ALL(['inca', 'inco', 'none'] /= config_inca)) THEN
+      WRITE(lunout,*)'setting config_inca="none" as you do not couple with INCA model'
+      config_inca = 'none'
+    END IF
 
 !-----------------------------------------------------------------------
@@ -198,71 +163,37 @@
 !
 !-----------------------------------------------------------------------
-    IF (type_trac == 'lmdz' .OR. type_trac == 'repr' .OR. type_trac == 'coag' .OR. type_trac == 'co2i') THEN
-       IF (type_trac=='co2i') THEN
-          nqCO2 = 1
-       ELSE
-          nqCO2 = 0
-       ENDIF
-       OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
-       IF(ierr.EQ.0) THEN
-          WRITE(lunout,*) trim(modname),': Open traceur.def : ok'
-          READ(90,*) nqtrue
-          write(lunout,*) 'nqtrue=',nqtrue
-       ELSE 
-          WRITE(lunout,*) trim(modname),': Failed opening traceur.def'
-          CALL abort_gcm(modname,"file traceur.def not found!",1)
-       ENDIF
-!jyg<
-!!       if ( planet_type=='earth') then
-!!         ! For Earth, water vapour & liquid tracers are not in the physics
-!!         nbtr=nqtrue-2
-!!       else
-!!         ! Other planets (for now); we have the same number of tracers
-!!         ! in the dynamics than in the physics
-!!         nbtr=nqtrue
-!!       endif
-!>jyg
-    ELSE ! type_trac=inca or inco
-       IF (type_trac=='inco') THEN
-          nqCO2 = 1
-       ELSE
-          nqCO2 = 0
-       ENDIF
-!jyg<
-       ! The traceur.def file is used to define the number "nqo" of water phases 
-       ! present in the simulation. Default : nqo = 2.
-       OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
-       IF(ierr.EQ.0) THEN
-          WRITE(lunout,*) trim(modname),': Open traceur.def : ok'
-          READ(90,*) nqo
-       ELSE 
-          WRITE(lunout,*) trim(modname),': Failed opening traceur.def'
-          CALL abort_gcm(modname,"file traceur.def not found!",1)
-       ENDIF
-       IF (nqo /= 2 .AND. nqo /= 3 ) THEN
-          IF (nqo == 4 .AND. type_trac=='inco') THEN ! ThL
-             WRITE(lunout,*) trim(modname),': you are coupling with INCA, and also using CO2i.'
-             nqo = 3    ! A ameliorier... je force 3 traceurs eau...  ThL
-             WRITE(lunout,*) trim(modname),': nqo = ',nqo
-          ELSE
-          WRITE(lunout,*) trim(modname),': nqo=',nqo, ' is not allowed. Only 2 or 3 water phases allowed'
-          CALL abort_gcm('infotrac_init','Bad number of water phases',1)
-          ENDIF
-       ENDIF
-       ! nbtr has been read from INCA by init_const_lmdz() in gcm.F 
+    OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
+    IF(ierr.EQ.0) THEN
+       WRITE(lunout,*) trim(modname),': Open traceur.def : ok'
+    ELSE 
+       WRITE(lunout,*) trim(modname),': Failed opening traceur.def'
+       CALL abort_gcm(modname,"file traceur.def not found!",1)
+    ENDIF
+    nqCO2 = 0; IF(type_trac == 'inco') nqCO2 = 1
+    SELECT CASE(type_trac)
+       CASE('lmdz','repr','coag','co2i'); READ(90,*) nqtrue
+       CASE('inca','inco');               READ(90,*) nqo
+          ! The traceur.def file is used to define the number "nqo" of water phases 
+          ! present in the simulation. Default : nqo = 2.
+          IF (nqo == 4 .AND. type_trac=='inco') nqo = 3
+          IF(ALL([2,3] /= nqo)) THEN
+             WRITE(lunout,*) trim(modname),': nqo=',nqo, ' is not allowed. Only 2 or 3 water phases allowed'
+             CALL abort_gcm('infotrac_init','Bad number of water phases',1)
+          END IF
+          ! nbtr has been read from INCA by init_const_lmdz() in gcm.F 
 #ifdef INCA
-       CALL Init_chem_inca_trac(nqINCA)
+          CALL Init_chem_inca_trac(nqINCA)
 #else
-       nqINCA=0
+          nqINCA=0
 #endif
-       nbtr=nqINCA+nqCO2
-       nqtrue=nbtr+nqo
-       WRITE(lunout,*) trim(modname),': nqo = ',nqo
-       WRITE(lunout,*) trim(modname),': nbtr = ',nbtr
-       WRITE(lunout,*) trim(modname),': nqtrue = ',nqtrue
-       WRITE(lunout,*) trim(modname),': nqCO2 = ',nqCO2
-       WRITE(lunout,*) trim(modname),': nqINCA = ',nqINCA
-       ALLOCATE(hadv_inca(nqINCA), vadv_inca(nqINCA), conv_flg_inca(nqINCA), pbl_flg_inca(nqINCA), solsym_inca(nqINCA))
-    ENDIF   ! type_trac 'inca' ou 'inco'
+          nbtr=nqINCA+nqCO2
+          nqtrue=nbtr+nqo
+          WRITE(lunout,*) trim(modname),': nqo    = ',nqo
+          WRITE(lunout,*) trim(modname),': nbtr   = ',nbtr
+          WRITE(lunout,*) trim(modname),': nqtrue = ',nqtrue
+          WRITE(lunout,*) trim(modname),': nqCO2 = ',nqCO2
+          WRITE(lunout,*) trim(modname),': nqINCA = ',nqINCA
+          ALLOCATE(hadv_inca(nqINCA), vadv_inca(nqINCA), conv_flg_inca(nqINCA), pbl_flg_inca(nqINCA), solsym_inca(nqINCA))
+    END SELECT
 !>jyg
 
@@ -306,51 +237,35 @@
 !    Get choice of advection schema from file tracer.def or from INCA
 !---------------------------------------------------------------------
-    IF (type_trac == 'lmdz' .OR. type_trac == 'repr' .OR. type_trac == 'coag' .OR. type_trac == 'co2i') THEN
-
-          ! Continue to read tracer.def
-          DO iq=1,nqtrue
-
-             write(*,*) 'infotrac 237: iq=',iq
-             ! CRisi: ajout du nom du fluide transporteur
-             ! mais rester retro compatible
-             READ(90,'(I2,X,I2,X,A)',IOSTAT=IOstatus) hadv(iq),vadv(iq),tchaine
-             write(lunout,*) 'iq,hadv(iq),vadv(iq)=',iq,hadv(iq),vadv(iq)
-             write(lunout,*) 'tchaine=',trim(tchaine)
-             write(*,*) 'infotrac 238: IOstatus=',IOstatus
-             if (IOstatus.ne.0) then
-                CALL abort_gcm('infotrac_init','Pb dans la lecture de traceur.def',1)
-             endif
-             ! Y-a-t-il 1 ou 2 noms de traceurs? -> On regarde s'il y a un
-             ! espace ou pas au milieu de la chaine.
-             continu=.true.
-             nouveau_traceurdef=.false.
-             iiq=1
-             do while (continu)
-                if (tchaine(iiq:iiq).eq.' ') then
-                  nouveau_traceurdef=.true.
-                  continu=.false.
-                else if (iiq.lt.LEN_TRIM(tchaine)) then
-                  iiq=iiq+1
-                else
-                  continu=.false.
-                endif
-             enddo
-             write(*,*) 'iiq,nouveau_traceurdef=',iiq,nouveau_traceurdef
-             if (nouveau_traceurdef) then
-                write(lunout,*) 'C''est la nouvelle version de traceur.def'
-                tnom_0(iq)=TRIM(tchaine(1:iiq-1))
-                tnom_transp(iq)=TRIM(tchaine(iiq+1:))
-             else
-                write(lunout,*) 'C''est l''ancienne version de traceur.def'
-                write(lunout,*) 'On suppose que les traceurs sont tous d''air'
-                tnom_0(iq)=tchaine
-                tnom_transp(iq) = 'air'
-             endif
-             write(lunout,*) 'tnom_0(iq)=<',trim(tnom_0(iq)),'>'
-             write(lunout,*) 'tnom_transp(iq)=<',trim(tnom_transp(iq)),'>'
-
-          ENDDO!DO iq=1,nqtrue
-
-          CLOSE(90)  
+    IF (ANY(['lmdz', 'repr', 'coag', 'co2i'] == type_trac)) THEN
+
+       ! Continue to read tracer.def
+       DO iq=1,nqtrue
+
+          write(*,*) 'infotrac 237: iq=',iq
+          ! CRisi: ajout du nom du fluide transporteur
+          ! mais rester retro compatible
+          READ(90,'(I2,X,I2,X,A)',IOSTAT=IOstatus) hadv(iq),vadv(iq),tchaine
+          write(lunout,*) 'iq,hadv(iq),vadv(iq)=',iq,hadv(iq),vadv(iq)
+          write(lunout,*) 'tchaine=',trim(tchaine)
+          write(*,*) 'infotrac 238: IOstatus=',IOstatus
+          if (IOstatus.ne.0) CALL abort_gcm('infotrac_init','Pb dans la lecture de traceur.def',1)
+          ! Y-a-t-il 1 ou 2 noms de traceurs separes par un espace ?
+          iiq = INDEX(tchaine(1:LEN_TRIM(tchaine)),' ')
+          nouveau_traceurdef=iiq/=0
+          write(*,*) 'iiq,nouveau_traceurdef=',iiq,nouveau_traceurdef
+          if (nouveau_traceurdef) then
+             IF(iq==1) write(lunout,*) "Nouvelle version de traceur.def"
+             tnom_0     (iq) = tchaine(1:iiq-1)
+             tnom_transp(iq) = tchaine(iiq+1:)
+          else
+             IF(iq==1) write(lunout,*) "Nouvelle version de traceur.def: traceurs d'air uniquement"
+             tnom_0     (iq) = tchaine
+             tnom_transp(iq) = 'air'
+          endif
+          write(lunout,*) 'tnom_0(iq)=<',trim(tnom_0(iq)),'>'
+          write(lunout,*) 'tnom_transp(iq)=<',trim(tnom_transp(iq)),'>'
+       ENDDO!DO iq=1,nqtrue
+
+       CLOSE(90)  
 
        WRITE(lunout,*) trim(modname),': Valeur de traceur.def :'
@@ -362,9 +277,5 @@
        IF ( planet_type=='earth') THEN
          !CR: nombre de traceurs de l eau
-         IF (tnom_0(3) == 'H2Oi') THEN
-            nqo=3
-         ELSE
-            nqo=2
-         ENDIF
+         nqo=2; IF (tnom_0(3) == 'H2Oi') nqo=3
          ! For Earth, water vapour & liquid tracers are not in the physics
          nbtr=nqtrue-nqo
@@ -375,52 +286,12 @@
        ENDIF
 
-#ifdef CPP_StratAer
-       IF (type_trac == 'coag') THEN
-         nbtr_bin=0
-         nbtr_sulgas=0
-         DO iq=1,nqtrue
-           IF (tnom_0(iq)(1:3)=='BIN') THEN !check if tracer name contains 'BIN'
-             nbtr_bin=nbtr_bin+1
-           ENDIF
-           IF (tnom_0(iq)(1:3)=='GAS') THEN !check if tracer name contains 'GAS'
-             nbtr_sulgas=nbtr_sulgas+1
-           ENDIF
-         ENDDO
-         print*,'nbtr_bin=',nbtr_bin
-         print*,'nbtr_sulgas=',nbtr_sulgas
-         DO iq=1,nqtrue
-           IF (tnom_0(iq)=='GASOCS') THEN
-             id_OCS_strat=iq-nqo
-           ENDIF
-           IF (tnom_0(iq)=='GASSO2') THEN
-             id_SO2_strat=iq-nqo
-           ENDIF
-           IF (tnom_0(iq)=='GASH2SO4') THEN
-             id_H2SO4_strat=iq-nqo
-           ENDIF
-           IF (tnom_0(iq)=='BIN01') THEN
-             id_BIN01_strat=iq-nqo
-           ENDIF
-           IF (tnom_0(iq)=='GASTEST') THEN
-             id_TEST_strat=iq-nqo
-           ENDIF
-         ENDDO
-         print*,'id_OCS_strat  =',id_OCS_strat
-         print*,'id_SO2_strat  =',id_SO2_strat
-         print*,'id_H2SO4_strat=',id_H2SO4_strat
-         print*,'id_BIN01_strat=',id_BIN01_strat
-       ENDIF
+    ENDIF
+!jyg<
+!
+
+! Transfert number of tracers to Reprobus
+#ifdef REPROBUS
+    IF (type_trac == 'repr') CALL Init_chem_rep_trac(nbtr,nqo,tnom_0)
 #endif
-
-    ENDIF  ! (type_trac == 'lmdz' .OR. type_trac == 'repr' .OR. type_trac = 'coag' .OR. type_trac = 'co2i')
-!jyg<
-!
-
-! Transfert number of tracers to Reprobus
-    IF (type_trac == 'repr') THEN
-#ifdef REPROBUS
-       CALL Init_chem_rep_trac(nbtr,nqo,tnom_0)
-#endif
-    ENDIF
 !
 ! Allocate variables depending on nbtr
@@ -432,84 +303,49 @@
     IF (type_trac == 'inca' .OR. type_trac == 'inco') THEN   ! config_inca='aero' ou 'chem'
 !>jyg
-! le module de chimie fournit les noms des traceurs
-! et les schemas d'advection associes. excepte pour ceux lus 
-! dans traceur.def 
-
-          DO iq=1,nqo+nqCO2
-
-             write(*,*) 'infotrac 237: iq=',iq
-             ! CRisi: ajout du nom du fluide transporteur
-             ! mais rester retro compatible
-             READ(90,'(I2,X,I2,X,A)',IOSTAT=IOstatus) hadv(iq),vadv(iq),tchaine
-             write(lunout,*) 'iq,hadv(iq),vadv(iq)=',iq,hadv(iq),vadv(iq)
-             write(lunout,*) 'tchaine=',trim(tchaine)
-             write(*,*) 'infotrac 238: IOstatus=',IOstatus
-             if (IOstatus.ne.0) then
-                CALL abort_gcm('infotrac_init','Pb dans la lecture de traceur.def',1)
-             endif
-             ! Y-a-t-il 1 ou 2 noms de traceurs? -> On regarde s'il y a un
-             ! espace ou pas au milieu de la chaine.
-             continu=.true.
-             nouveau_traceurdef=.false.
-             iiq=1
-
-             do while (continu)
-                if (tchaine(iiq:iiq).eq.' ') then
-                  nouveau_traceurdef=.true.
-                  continu=.false.
-                else if (iiq.lt.LEN_TRIM(tchaine)) then
-                  iiq=iiq+1
-                else
-                  continu=.false.
-                endif
-             enddo
-
-             write(*,*) 'iiq,nouveau_traceurdef=',iiq,nouveau_traceurdef
-
-             if (nouveau_traceurdef) then
-                write(lunout,*) 'C''est la nouvelle version de traceur.def'
-                tnom_0(iq)=tchaine(1:iiq-1)
-                tnom_transp(iq)=tchaine(iiq+1:)
-             else
-                write(lunout,*) 'C''est l''ancienne version de traceur.def'
-                write(lunout,*) 'On suppose que les traceurs sont tous d''air'
-                tnom_0(iq)=tchaine
-                tnom_transp(iq) = 'air'
-             endif
-
-             write(lunout,*) 'tnom_0(iq)=<',trim(tnom_0(iq)),'>'
-             write(lunout,*) 'tnom_transp(iq)=<',trim(tnom_transp(iq)),'>'
-
-          ENDDO  !DO iq=1,nqo
-          CLOSE(90)  
-
- 
+! le module de chimie fournit les noms des traceurs et les schemas d'advection associes.
+! excepte pour ceux lus dans traceur.def 
+
 #ifdef INCA
-       CALL init_transport( &
-            hadv_inca, &
-            vadv_inca, &
-            conv_flg_inca, &
-            pbl_flg_inca,  &
-            solsym_inca)
-
-       conv_flg(1+nqCO2:nbtr) = conv_flg_inca
-       pbl_flg(1+nqCO2:nbtr) = pbl_flg_inca
-       solsym(1+nqCO2:nbtr) = solsym_inca
-
-       IF (type_trac == 'inco') THEN
-          conv_flg(1:nqCO2) = 1
-          pbl_flg(1:nqCO2) = 1
-          solsym(1:nqCO2) = 'CO2'
-       ENDIF
+       CALL init_transport(hadv_inca, vadv_inca, conv_flg_inca, pbl_flg_inca, solsym_inca)
+       ! DC passive CO2 tracer is at index 1: H2O was removed ; nqCO2/=0 in "inco" case only
+       conv_flg(1:nqCO2) = 1;   conv_flg(1+nqCO2:nbtr) = conv_flg_inca
+        pbl_flg(1:nqCO2) = 1;    pbl_flg(1+nqCO2:nbtr) =  pbl_flg_inca
+         solsym(1:nqCO2) = 'CO2'; solsym(1+nqCO2:nbtr) =   solsym_inca
 #endif
 
-!jyg<
-       DO iq = nqo+nqCO2+1, nqtrue
-          hadv(iq) = hadv_inca(iq-nqo-nqCO2)
-          vadv(iq) = vadv_inca(iq-nqo-nqCO2) 
-          tnom_0(iq)=solsym_inca(iq-nqo-nqCO2)
-          tnom_transp(iq) = 'air'
+       itr = 0
+       DO iq = 1, nqtot
+          IF(iq > nqo+nqCO2) THEN
+             itr = itr+1
+             hadv  (iq) = hadv_inca  (itr)
+             vadv  (iq) = vadv_inca  (itr) 
+             tnom_0(iq) = solsym_inca(itr)
+             tnom_transp(iq) = 'air'
+             CYCLE
+          END IF
+          write(*,*) 'infotrac 237: iq=',iq
+          ! CRisi: ajout du nom du fluide transporteur en restant retro-compatible
+          READ(90,'(I2,X,I2,X,A)',IOSTAT=IOstatus) hadv(iq),vadv(iq),tchaine
+          write(lunout,*) 'iq,hadv(iq),vadv(iq)=',iq,hadv(iq),vadv(iq)
+          write(lunout,*) 'tchaine=',trim(tchaine)
+          write(*,*) 'infotrac 238: IOstatus=',IOstatus
+          if (IOstatus.ne.0) CALL abort_gcm('infotrac_init','Pb dans la lecture de traceur.def',1)
+          ! Y-a-t-il 1 ou 2 noms de traceurs separes par un espace ?
+          iiq = INDEX(tchaine(1:LEN_TRIM(tchaine)),' ')
+          nouveau_traceurdef=iiq/=0
+          write(*,*) 'iiq,nouveau_traceurdef=',iiq,nouveau_traceurdef
+          if (nouveau_traceurdef) then
+             IF(iq==1) write(lunout,*) "Nouvelle version de traceur.def"
+             tnom_0     (iq) = tchaine(1:iiq-1)
+             tnom_transp(iq) = tchaine(iiq+1:)
+          else
+             IF(iq==1) write(lunout,*) "Nouvelle version de traceur.def: traceurs d'air uniquement"
+             tnom_0     (iq) = tchaine
+             tnom_transp(iq) = 'air'
+          endif
+          write(lunout,*) 'tnom_0(iq)=<',trim(tnom_0(iq)),'>'
+          write(lunout,*) 'tnom_transp(iq)=<',trim(tnom_transp(iq)),'>'
        END DO
-
+       CLOSE(90)  
     ENDIF ! (type_trac == 'inca' or 'inco')
 
@@ -554,5 +390,4 @@
 !
     ALLOCATE(tracers(nqtot))
-    ALLOCATE(niadv(nqtot))
 
 !-----------------------------------------------------------------------
@@ -604,23 +439,9 @@
     END DO
 
-!
-! Find vector keeping the correspodence between true and total tracers
-!
-    niadv(:)=0
-    iiq=0
+    WRITE(lunout,*) trim(modname),': Information stored in infotrac :'
+    WRITE(lunout,*) trim(modname),': iadv  name  long_name :'
+
     DO iq=1,nqtot
-       IF(tracers(iq)%iadv.GE.0) THEN
-          ! True tracer
-          iiq=iiq+1
-          niadv(iiq)=iq
-       ENDIF
-    END DO
-
-
-    WRITE(lunout,*) trim(modname),': Information stored in infotrac :'
-    WRITE(lunout,*) trim(modname),': iadv  niadv  name  long_name :'
-
-    DO iq=1,nqtot
-       WRITE(lunout,*) tracers(iq)%iadv,niadv(iq), ' ',trim(tracers(iq)%name),' ',trim(tracers(iq)%longName)
+       WRITE(lunout,*) tracers(iq)%iadv,' ',trim(tracers(iq)%name),' ',trim(tracers(iq)%longName)
     END DO
 
@@ -645,5 +466,4 @@
 ! + verifier que tous les peres sont ecrits en premieres positions
     ALLOCATE(iqfils(nqtot,nqtot))   
-    nqperes=0
     iqfils(:,:)=0
     tracers(:)%iqParent=0
@@ -652,5 +472,4 @@
         ! ceci est un traceur pere
         WRITE(lunout,*) 'Le traceur',iq,', appele ',trim(tnom_0(iq)),', est un pere'
-        nqperes=nqperes+1
         tracers(iq)%iqParent=0
       else !if (tnom_transp(iq) == 'air') then
@@ -682,5 +501,5 @@
       endif !if (tnom_transp(iq) == 'air') then
     enddo !DO iq=1,nqtot
-    WRITE(lunout,*) 'infotrac: nqperes=',nqperes    
+    WRITE(lunout,*) 'infotrac: nqGen0=',COUNT(tracers(:)%parent == 'air')
     WRITE(lunout,*) 'nqChilds=',tracers(:)%nqChilds
     WRITE(lunout,*) 'iqParent=',tracers(:)%iqParent
@@ -738,5 +557,4 @@
     tracers(:)%isH2Ofamily = [(tracers(iq)%gen0Name(1:3) == 'H2O', iq=1, nqtot)]
 
-
 ! detecter quels sont les traceurs isotopiques parmi des traceurs
     call infotrac_isoinit(tnom_0,nqtrue)
@@ -754,18 +572,6 @@
         write(lunout,*) 'infotrac 704: nqtottr,nqtot,nqo=',nqtottr,nqtot,nqo
         ! Rq: nqtottr n'est pas forcement egal a nbtr dans le cas ou new_iq /= nqtrue
-        ALLOCATE (itr_indice(nqtottr))  
-        itr_indice(:)=0  
-        itr=0
-        do iq=nqo+1, nqtot
-          if (tracers(iq)%iso_iName.eq.0) then
-            itr=itr+1
-            write(*,*) 'itr=',itr
-            itr_indice(itr)=iq
-          endif !if (tracers(iq)%iso_iName.eq.0) then
-        enddo
-        if (itr.ne.nqtottr) then
+        if (COUNT(tracers(:)%iso_iName == 0) /= nqtottr) &
             CALL abort_gcm('infotrac_init','pb dans le calcul de nqtottr',1)
-        endif
-        write(lunout,*) 'itr_indice=',itr_indice
 !    endif !if (ntraciso.gt.0) then
 
